Cutlass CUDA Templates for Linear Algebra Subroutines and Solvers

Public Types | Public Member Functions | Public Attributes | List of all members
cutlass::TileAllocation< Scalar_, Shape_ > Struct Template Reference

Class for storing a tile in memory and accessing it through a tensor ref.

`#include <tile_allocation.h>`

## Public Types
typedef Scalar_ | Scalar
| Scalar element. More...
typedef StorageType< sizeof(Scalar)>::Type | Storage
| The actual storage (may differ from the scalar type) More...
typedef Shape_ | Shape
| Size of the allocation in units of scalars. More...
typedef ShapeStrides< Shape, 1 >::Shape | Strides
| Strides. More...
typedef TensorRef< Scalar const, 4 > | ConstTensorRef
| Defines the tensor reference for this allocation. More...
typedef TensorRef< Scalar, 4 > | TensorRef
| Defines the tensor reference for this allocation. More...
typedef TensorView< Scalar const, 4 > | ConstTensorView
| View of memory. More...
typedef TensorView< Scalar, 4 > | TensorView
| View of memory. More...

## Public Member Functions
CUTLASS_DEVICE Scalar * | data ()
| Returns a pointer to the raw data. More...
CUTLASS_DEVICE Scalar const * | data () const
| Returns a const pointer to the raw data. More...
CUTLASS_DEVICE TensorRef | reference ()
| Returns a TensorRef object pointing to the data. More...
CUTLASS_DEVICE ConstTensorRef | reference () const
| Returns a TensorRef object pointing to the data. More...
CUTLASS_DEVICE TensorView | view ()
| Returns a TensorView object pointing to the data. More...
CUTLASS_DEVICE ConstTensorView | view () const
| Returns a TensorView object pointing to the data. More...

## Public Attributes
Storage | storage [Shape::kD][Shape::kH][Shape::kW][Shape::kC]
| Storage. More...

## Member Typedef Documentation

## ◆ ConstTensorRef

template<typename Scalar_ , typename Shape_ >

typedef TensorRef<Scalar const, 4> cutlass::TileAllocation< Scalar_, Shape_ >::ConstTensorRef

## ◆ ConstTensorView

template<typename Scalar_ , typename Shape_ >

typedef TensorView<Scalar const, 4> cutlass::TileAllocation< Scalar_, Shape_ >::ConstTensorView

## ◆ Scalar

template<typename Scalar_ , typename Shape_ >

typedef Scalar_ cutlass::TileAllocation< Scalar_, Shape_ >::Scalar

## ◆ Shape

template<typename Scalar_ , typename Shape_ >

typedef Shape_ cutlass::TileAllocation< Scalar_, Shape_ >::Shape

## ◆ Storage

template<typename Scalar_ , typename Shape_ >

typedef StorageType<sizeof(Scalar)>::Type cutlass::TileAllocation< Scalar_, Shape_ >::Storage

## ◆ Strides

template<typename Scalar_ , typename Shape_ >

typedef ShapeStrides<Shape, 1>::Shape cutlass::TileAllocation< Scalar_, Shape_ >::Strides

## ◆ TensorRef

template<typename Scalar_ , typename Shape_ >

typedef TensorRef<Scalar, 4> cutlass::TileAllocation< Scalar_, Shape_ >::TensorRef

## ◆ TensorView

template<typename Scalar_ , typename Shape_ >

typedef TensorView<Scalar, 4> cutlass::TileAllocation< Scalar_, Shape_ >::TensorView

## Member Function Documentation

## ◆ data() [1/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE Scalar* cutlass::TileAllocation< Scalar_, Shape_ >::data | ( |  | ) |
| inline

## ◆ data() [2/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE Scalar const* cutlass::TileAllocation< Scalar_, Shape_ >::data | ( |  | ) | const
| inline

## ◆ reference() [1/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE TensorRef cutlass::TileAllocation< Scalar_, Shape_ >::reference | ( |  | ) |
| inline

## ◆ reference() [2/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE ConstTensorRef cutlass::TileAllocation< Scalar_, Shape_ >::reference | ( |  | ) | const
| inline

## ◆ view() [1/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE TensorView cutlass::TileAllocation< Scalar_, Shape_ >::view | ( |  | ) |
| inline

## ◆ view() [2/2]

template<typename Scalar_ , typename Shape_ >

CUTLASS_DEVICE ConstTensorView cutlass::TileAllocation< Scalar_, Shape_ >::view | ( |  | ) | const
| inline

## Member Data Documentation

## ◆ storage

template<typename Scalar_ , typename Shape_ >

Storage cutlass::TileAllocation< Scalar_, Shape_ >::storage[Shape::kD][Shape::kH][Shape::kW][Shape::kC]

The documentation for this struct was generated from the following file:

- tile_allocation.h